VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   690
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   ScaleHeight     =   690
   ScaleWidth      =   4560
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox Picture1 
      Height          =   225
      Left            =   30
      ScaleHeight     =   165
      ScaleWidth      =   4395
      TabIndex        =   1
      Top             =   30
      Width           =   4455
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Run"
      Height          =   345
      Left            =   30
      TabIndex        =   0
      Top             =   300
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 03/2020
'
' Das ist nur ein Beispiel/Testcode! Fr entsprechende Infos zum SourceReader/SinkWriter
' und entsprechenden MediaTypes, die hier im Beispiel verwendet werden, und wie das ganze
' funktioniert, bitte die Media Foundation Doku lesen!
'
' In diesem Beispiel wird nur das Prinzip gezeigt wie aus einer beliebigen, von der
' Media Foundation untersttzte, Audio- oder Video-Datei eine M4A-Audio Datei erstellt
' werden kann.
'
' strInFile entsprechend anpassen!

Option Explicit

Private Sub Command1_Click()

    Dim pSample As Long
    Dim pSinkWriter As Long
    Dim pSourceReader As Long
    Dim lngEnd As Long
    Dim lngStart As Long
    Dim lngStreamFlags As Long
    Dim lngStreamIndex As Long
    Dim lngActualStreamIndex As Long
    Dim curComplete As Currency
    Dim curTimestamp As Currency
    Dim curSampleDuration As Currency
    Dim tPROPVARIANT As PROPVARIANT
    Dim varRet As Variant
    Dim strInFile As String
    Dim strOutFile As String
    Dim bolEndOfStream As Boolean

    bolEndOfStream = False
    
    strInFile = App.Path & "\test.mp3" ' beliebiges, von der Media Foundation untersttztes Audio- oder Video-Format
    strOutFile = App.Path & "\neu.m4a" ' fr dieses Bsp., Konvertierung zu M4A

    ' Media Foundation initialisieren
    If MFStartup(MF_VERSION, MF_STARTUP_FULL) = S_OK Then
    
        ' SourceReader erstellen
        If CreateSourceReader(strInFile, pSourceReader) = True Then
        
            ' Duration der Source ermitteln
            If Invoke(pSourceReader, GetPresentationAttribute, MF_SOURCE_READER_MEDIASOURCE, _
                VarPtr(Str2Guid(MF_PD_DURATION)), VarPtr(tPROPVARIANT)) = S_OK Then
                
                ' PROPVARIANT konvertieren
                If PropVariantChangeType(VarPtr(varRet), tPROPVARIANT, 0&, VT_R8) = S_OK Then
                
                    Picture1.Cls
                    Picture1.Scale (0, 0)-(CCur(varRet), 1)
                
                    Call PropVariantClear(tPROPVARIANT)
                    
                End If
                
            End If
        
            ' SinkWriter erstellen
            If CreateSinkWriter(strOutFile, pSinkWriter, lngStreamIndex) = True Then
            
                ' mit dem schreiben in den SinkWriter beginnen
                If Invoke(pSinkWriter, BeginWriting) = S_OK Then
                
                    ' Startzeit der Konvertierung
                    lngStart = GetTickCount
                
                    Do
                
                        ' Sample vom SourceReader lesen
                        If Invoke(pSourceReader, ReadSample, MF_SOURCE_READER_FIRST_AUDIO_STREAM, _
                            0&, VarPtr(lngActualStreamIndex), VarPtr(lngStreamFlags), VarPtr( _
                            curTimestamp), VarPtr(pSample)) = S_OK Then
                            
                            ' nur wenn das Ende des Streams noch nicht erreicht wurde
                            If CBool(lngStreamFlags And MF_SOURCE_READER_FLAG.MF_SOURCE_READERF_ENDOFSTREAM) = False Then
                            
                                curSampleDuration = 0

                                ' Sample-Duration ermitteln
                                If Invoke(pSample, GetSampleDuration, VarPtr(curSampleDuration)) = S_OK Then

                                    Picture1.Cls
                                    Picture1.Line (0, 0)-((curTimestamp * 10000) + _
                                        (curSampleDuration * 10000), 1), vbGreen, BF

                                End If
                                
                                ' Ab hier knnte man vom IMFSample ein IMFMediaBuffer holen
                                ' um die PCM Daten zB. fr Effekte o.. zu manipulieren. Die
                                ' genderten Daten wieder in ein IMFMediaBuffer schreiben,
                                ' daraus dann wieder ein IMFSample erstellen und dem SinkWriter
                                ' bergeben.
                        
                                ' Sample dem SinkWriter zum schreiben bergeben
                                If Invoke(pSinkWriter, WriteSample, lngStreamIndex, pSample) <> S_OK Then
                                
                                    ' hier ist dann was beim schreiben des Sample schief gegangen
                                    Debug.Print "Fehler beim schreiben des Sample."
                                    
                                    ' Konvertierung beenden
                                    bolEndOfStream = True
                                    
                                End If
                                
                            Else
                            
                                ' Ende des Streams vom SourceReader erreicht
                                ' Konvertierung beenden
                                bolEndOfStream = True
                
                            End If
                
                        Else
                            
                            ' hier ist dann was beim lesen des Sample schief gegangen
                            Debug.Print "Fehler beim lesen des Sample."
                            
                            ' Konvertierung beenden
                            bolEndOfStream = True
                            
                        End If
                        
                        ' freigeben
                        Call Release(pSample)
                        
                        DoEvents
                    
                    ' solange durchlaufen bis das Ende des Streams vom SourceReader erreicht ist
                    ' oder beim lesen/schreiben eines Sample ein Fehler auftritt.
                    Loop Until bolEndOfStream = True
                    
                    ' Endzeit der Konvertierung
                    lngEnd = GetTickCount - lngStart
                    
                    ' kurze Pause zur Sicherheit damit die restlichen Daten geschrieben werden knnen
                    Call Delay(0.5)
                    
                    ' was dann noch an Daten brig ist, verwerfen
                    Call Invoke(pSinkWriter, Flush, MF_SINK_WRITER_ALL_STREAMS)
                
                    ' schreiben abschlieen
                    Call Invoke(pSinkWriter, Finalize)
                
                End If
                
                ' freigeben
                Call Release(pSinkWriter)
                
            End If
        
            ' freigeben
            Call Release(pSourceReader)
            
        End If
            
        ' Media Foundation beenden
        Call MFShutdown
            
        MsgBox "Konvertierung von '" & strInFile & "' zu '" & strOutFile & _
            "' abgeschlossen. Dauer: " & CStr(lngEnd) & "ms", vbOKOnly Or _
            vbInformation, "SourceReader/SinkWriter Sample"
    
    End If

End Sub

' SourceReader von einer Datei erstellen
Private Function CreateSourceReader(ByVal sURL As String, ByRef pReader As Long) _
    As Boolean

    Dim bolRet As Boolean
    Dim pMediaTypeOut As Long

    bolRet = False

    ' SourceReader erstellen
    If MFCreateSourceReaderFromURL(StrPtr(sURL), 0&, pReader) = S_OK Then

        ' Output MediaType fr den SourceReader erstellen/festlegen
        ' fr dieses Bsp: PCM, 44.1kHz, 16bit, Stereo
        If CreateInOutputType(pMediaTypeOut) = True Then

            ' Output MediaType fr den SourceReader setzen
            If Invoke(pReader, SetCurrentMediaType, _
                MF_SOURCE_READER_FIRST_AUDIO_STREAM, _
                0&, pMediaTypeOut) = S_OK Then

                bolRet = True

            End If

            ' freigeben
            Call Release(pMediaTypeOut)

        End If

    End If

    CreateSourceReader = bolRet

End Function

' SinkWriter von einer Datei erstellen
Private Function CreateSinkWriter(ByVal sURL As String, ByRef pWriter As Long, _
    ByRef lStreamIndex As Long) As Boolean

    Dim bolRet As Boolean
    Dim pMediaTypeIn As Long
    Dim pMediaTypeOut As Long

    bolRet = False

    ' SinkWriter erstellen
    If MFCreateSinkWriterFromURL(StrPtr(sURL), 0&, 0&, pWriter) = S_OK Then

        ' Output MediaType fr den SinkWriter erstellen/festlegen
        ' fr dieses Bsp: AAC, 44.1kHz, 16bit, 192kB/s, Stereo
        If CreateSinkWriterOutputType(pMediaTypeOut) = True Then

            ' Output MediaType Stream hinzufgen
            If Invoke(pWriter, AddStream, pMediaTypeOut, _
                VarPtr(lStreamIndex)) = S_OK Then

                ' Input MediaType fr den SinkWriter erstellen/festlegen
                ' fr dieses Bsp: PCM, 44.1kHz, 16bit, Stereo
                If CreateInOutputType(pMediaTypeIn) = True Then

                    ' Input MediaType fr den SinkWriter setzen
                    If Invoke(pWriter, SetInputMediaType, lStreamIndex, _
                        pMediaTypeIn, 0&) = S_OK Then

                        bolRet = True

                    End If

                    ' freigeben
                    Call Release(pMediaTypeIn)

                End If

            End If

            ' freigeben
            Call Release(pMediaTypeOut)

        End If
    
    End If

    CreateSinkWriter = bolRet

End Function

' MediaType fr den SourceReader (Output) und dem SinkWriter (Input)
' erstellen. Sollten fr beide Interfaces gleich sein!
' Hier als Bsp: PCM, 44.1kHz, 16bit, Stereo
Private Function CreateInOutputType(ByRef pType As Long) As Boolean

    Dim bolRet As Boolean

    bolRet = False

    ' MediaType erstellen
    If MFCreateMediaType(pType) = S_OK Then
        
        ' MajorType Audio setzen
        If Invoke(pType, SetGUID, VarPtr(Str2Guid(MF_MT_MAJOR_TYPE)), _
            VarPtr(Str2Guid(MFMediaType_Audio))) = S_OK Then
            
            ' SubType PCM setzen
            If Invoke(pType, SetGUID, VarPtr(Str2Guid(MF_MT_SUBTYPE)), _
                VarPtr(Str2Guid(MFAudioFormat_PCM))) = S_OK Then
                        
                ' 44.1 kHz
                If Invoke(pType, SetUINT32, _
                    VarPtr(Str2Guid(MF_MT_AUDIO_SAMPLES_PER_SECOND)), _
                    CLng(44100)) = S_OK Then
                    
                    ' 16 bit
                    If Invoke(pType, SetUINT32, _
                        VarPtr(Str2Guid(MF_MT_AUDIO_BITS_PER_SAMPLE)), _
                        CLng(16)) = S_OK Then

                        ' 2 Channel
                        If Invoke(pType, SetUINT32, _
                            VarPtr(Str2Guid(MF_MT_AUDIO_NUM_CHANNELS)), _
                            CLng(2)) = S_OK Then
                        
                            bolRet = True
                            
                        End If
                        
                    End If
                    
                End If
                        
            End If
                
        End If
        
    End If

    CreateInOutputType = bolRet
    
End Function

' MediaType fr den SinkWriter (Output) erstellen. Hier als Bsp. fr M4A.
' AAC, 44.1kHz, 16bit, 192kb/s, Stereo
Private Function CreateSinkWriterOutputType(ByRef pOutputType As Long) As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    ' MediaType erstellen
    If MFCreateMediaType(pOutputType) = S_OK Then

        ' MajorType setzen
        If Invoke(pOutputType, SetGUID, _
            VarPtr(Str2Guid(MF_MT_MAJOR_TYPE)), _
            VarPtr(Str2Guid(MFMediaType_Audio))) = S_OK Then

            ' SubType setzen
            If Invoke(pOutputType, SetGUID, _
                VarPtr(Str2Guid(MF_MT_SUBTYPE)), _
                VarPtr(Str2Guid(MFAudioFormat_AAC))) = S_OK Then

                ' 44.1 kHz
                If Invoke(pOutputType, SetUINT32, _
                    VarPtr(Str2Guid(MF_MT_AUDIO_SAMPLES_PER_SECOND)), _
                    CLng(44100)) = S_OK Then
                
                    ' 16 bit
                    If Invoke(pOutputType, SetUINT32, _
                        VarPtr(Str2Guid(MF_MT_AUDIO_BITS_PER_SAMPLE)), _
                        CLng(16)) = S_OK Then

                        ' 2 Channel
                        If Invoke(pOutputType, SetUINT32, _
                            VarPtr(Str2Guid(MF_MT_AUDIO_NUM_CHANNELS)), _
                            CLng(2)) = S_OK Then
                    
                            ' 192 kB/s
                            If Invoke(pOutputType, SetUINT32, _
                                VarPtr(Str2Guid(MF_MT_AVG_BITRATE)), _
                                CLng(192000)) = S_OK Then
                                    
                                bolRet = True

                            End If
                        
                        End If
                    
                    End If
                
                End If
            
            End If
        
        End If
        
    End If

    CreateSinkWriterOutputType = bolRet
    
End Function
