Attribute VB_Name = "modInterface"
Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Public Const VT_R8 As Integer = 5

Public Const MF_STARTUP_FULL As Long = &H0&
Public Const MF_VERSION As Long = &H1&

Public Const CLSCTX_INPROC As Long = &H1&
Public Const CC_STDCALL As Long = &H4&
Public Const IID_Release As Long = &H8&

Public Const MF_SINK_WRITER_ALL_STREAMS As Long = &HFFFFFFFE
Public Const MF_SOURCE_READER_FIRST_AUDIO_STREAM As Long = &HFFFFFFFD
Public Const MF_SOURCE_READER_MEDIASOURCE As Long = &HFFFFFFFF

Public Const MF_PD_DURATION As String = "{6c990d33-bb8e-477a-8598-0d5d96fcd88a}"

Public Const MF_MT_MAJOR_TYPE As String = "{48EBA18E-F8C9-4687-BF11-0A74C9F96A8F}"
Public Const MF_MT_SUBTYPE As String = "{F7E34C9A-42E8-4714-B74B-CB29D72C35E5}"

Public Const MFMediaType_Audio As String = "{73647561-0000-0010-8000-00AA00389B71}"
Public Const MFAudioFormat_PCM As String = "{00000001-0000-0010-8000-00AA00389B71}"
Public Const MFAudioFormat_AAC As String = "{00001610-0000-0010-8000-00aa00389b71}"

Public Const MF_MT_AUDIO_SAMPLES_PER_SECOND As String = "{5faeeae7-0290-4c31-9e8a-c534f68d9dba}"
Public Const MF_MT_AUDIO_BITS_PER_SAMPLE As String = "{f2deb57f-40fa-4764-aa33-ed4f2d1ff669}"
Public Const MF_MT_AUDIO_NUM_CHANNELS As String = "{37e48bf5-645e-4c5b-89de-ada9e29b696a}"
Public Const MF_MT_AVG_BITRATE As String = "{20332624-fb0d-4d9e-bd0d-cbf6786c102e}"

' ----==== Enums ====----
Public Enum vtb_Interfaces
    
    'IUnknown
    QueryInterface = 0
    
    'IMFSourceReader
    SetCurrentMediaType = 7
    ReadSample = 9
    GetPresentationAttribute = 12
    
    'IMFSinkWriter
    AddStream = 3
    SetInputMediaType = 4
    BeginWriting = 5
    WriteSample = 6
    Flush = 10
    Finalize = 11

    'IMFMediaType
    SetUINT32 = 21
    SetGUID = 24
    
    'IMFSample
    GetSampleDuration = 37
    
End Enum

Public Enum MF_SOURCE_READER_FLAG
    MF_SOURCE_READERF_ERROR = &H1&
    MF_SOURCE_READERF_ENDOFSTREAM = &H2&
    MF_SOURCE_READERF_NEWSTREAM = &H4&
    MF_SOURCE_READERF_NATIVEMEDIATYPECHANGED = &H10&
    MF_SOURCE_READERF_CURRENTMEDIATYPECHANGED = &H20&
    MF_SOURCE_READERF_STREAMTICK = &H100&
    MF_SOURCE_READERF_ALLEFFECTSREMOVED = &H200&
End Enum

' ----==== Type ====----
Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

' ----==== Kernel32.dll Deklarationen ====----
Public Declare Sub Sleep Lib "Kernel32.dll" ( _
                   ByVal lngMilliseconds As Long)

Public Declare Sub CopyMemory Lib "Kernel32.dll" _
                   Alias "RtlMoveMemory" ( _
                   ByRef pTo As Any, _
                   ByRef uFrom As Any, _
                   ByVal lSize As Long)

Public Declare Function GetTickCount Lib "Kernel32.dll" () As Long

Public Declare Function lstrlenW Lib "Kernel32.dll" ( _
                        ByVal lpString As Long) As Long

' ----==== Ole32 API-Deklarationen ====----
Public Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                   ByVal hMem As Long)

Public Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                        ByVal pString As Long, _
                        ByRef pCLSID As GUID) As Long

Public Declare Function StringFromGUID Lib "Ole32.dll" _
                        Alias "StringFromIID" ( _
                        ByRef pCLSID As GUID, _
                        ByRef lpszProgID As Long) As Long

Public Declare Function PropVariantClear Lib "Ole32.dll" ( _
                        ByRef pVar As PROPVARIANT) As Long

' ----==== Oleaut32.dll Deklarationen ====----
Public Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                        ByVal pvInstance As Long, _
                        ByVal oVft As Long, _
                        ByVal cc As Long, _
                        ByVal vtReturn As VbVarType, _
                        ByVal cActuals As Long, _
                        ByVal prgvt As Any, _
                        ByVal prgpvarg As Any, _
                        ByRef pvargResult As Variant) As Long

' ----==== Propsys.dll Deklarationen ====----
Public Declare Function PropVariantChangeType Lib "Propsys.dll" ( _
                        ByVal ppropvarDest As Long, _
                        ByRef propvarSrc As PROPVARIANT, _
                        ByVal flags As Long, _
                        ByVal vt As Integer) As Long

' ----==== Mfplat.dll Deklarationen ====----
Public Declare Function MFStartup Lib "Mfplat.dll" ( _
                        ByVal Version As Long, _
                        ByVal dwFlags As Long) As Long

Public Declare Function MFShutdown Lib "Mfplat.dll" () As Long

Public Declare Function MFCreateMediaType Lib "Mfplat.dll" ( _
                        ByRef ppMFType As Long) As Long

' ----==== Mfreadwrite.dll Deklarationen ====----
Public Declare Function MFCreateSourceReaderFromURL Lib "Mfreadwrite.dll" ( _
                        ByVal pwszURL As Long, _
                        ByVal pAttributes As Long, _
                        ByRef ppSourceReader As Long) As Long

Public Declare Function MFCreateSinkWriterFromURL Lib "Mfreadwrite.dll" ( _
                        ByVal pwszOutputURL As Long, _
                        ByVal pByteStream As Long, _
                        ByVal pAttributes As Long, _
                        ByRef ppSinkWriter As Long) As Long

' ----==== Call OleInvoke ====----
Public Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

' ----==== Release Interface ====----
Public Sub Release(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Private Function OleInvoke(ByVal pInterface As Long, ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lItem As Long
    Dim lCount As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' wenn ein Pointer auf ein Interface vorhanden ist
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Funktion des Interfaces aufrufen
        If DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If

    OleInvoke = vRet

End Function

' ----==== String -> GUID ====----
Public Function Str2Guid(ByVal str As String) As GUID

    Call CLSIDFromString(StrPtr(str), Str2Guid)
    
End Function

' ----==== GUID -> String ====----
Public Function Guid2Str(ByRef tGUID As GUID) As String

    Dim lGuid As Long

    If StringFromGUID(tGUID, lGuid) = S_OK Then

        Guid2Str = Ptr2Str(lGuid)
    
    End If

End Function

' ----==== Pointer -> String ====----
Public Function Ptr2Str(ByVal lpStrPointer As Long) As String

    Dim lLen As Long
    Dim bBuffer() As Byte

    If lpStrPointer = 0 Then Exit Function

    lLen = lstrlenW(lpStrPointer) * 2& - 1&

    If lLen > 0& Then

        ReDim bBuffer(lLen)

        Call CopyMemory(bBuffer(0), ByVal lpStrPointer, lLen)
        
        Call CoTaskMemFree(lpStrPointer)

        Ptr2Str = bBuffer

    End If

End Function

' ----==== Delay ====----
Public Sub Delay(ByVal SecsDelay As Single)

    Dim TimeOut   As Single
    Dim PrevTimer As Single

    PrevTimer = Timer
    TimeOut = PrevTimer + SecsDelay

    Do While PrevTimer < TimeOut

        Call Sleep(1)

        DoEvents

        If Timer < PrevTimer Then TimeOut = TimeOut - 86400

        PrevTimer = Timer

    Loop

End Sub

